xref: /openbmc/u-boot/scripts/kconfig/Makefile (revision 752a0b08)
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
6	localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14# We need this, in case the user has it in its environment
15unexport CONFIG_
16
17xconfig: $(obj)/qconf
18	$< $(Kconfig)
19
20gconfig: $(obj)/gconf
21	$< $(Kconfig)
22
23menuconfig: $(obj)/mconf
24	$< $(Kconfig)
25
26config: $(obj)/conf
27	$< --oldaskconfig $(Kconfig)
28
29nconfig: $(obj)/nconf
30	$< $(Kconfig)
31
32oldconfig: $(obj)/conf
33	$< --$@ $(Kconfig)
34
35silentoldconfig: $(obj)/conf
36	$(Q)mkdir -p include/config include/generated
37	$< --$@ $(Kconfig)
38
39localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
40	$(Q)mkdir -p include/config include/generated
41	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
42	$(Q)if [ -f .config ]; then 					\
43			cmp -s .tmp.config .config ||			\
44			(mv -f .config .config.old.1;			\
45			 mv -f .tmp.config .config;			\
46			 $(obj)/conf --silentoldconfig $(Kconfig);	\
47			 mv -f .config.old.1 .config.old)		\
48	else								\
49			mv -f .tmp.config .config;			\
50			$(obj)/conf --silentoldconfig $(Kconfig);	\
51	fi
52	$(Q)rm -f .tmp.config
53
54# Create new linux.pot file
55# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
56update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
57	$(Q)echo "  GEN     config.pot"
58	$(Q)xgettext --default-domain=linux                         \
59	    --add-comments --keyword=_ --keyword=N_                 \
60	    --from-code=UTF-8                                       \
61	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
62	    --directory=$(srctree) --directory=$(objtree)           \
63	    --output $(obj)/config.pot
64	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
65	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
66	    $(srctree)/arch/*/um/Kconfig`;               \
67	    do                                           \
68		echo "  GEN     $$i";                    \
69		$(obj)/kxgettext $$i                     \
70		     >> $(obj)/config.pot;               \
71	    done )
72	$(Q)echo "  GEN     linux.pot"
73	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
74	    --output $(obj)/linux.pot
75	$(Q)rm -f $(obj)/config.pot
76
77PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
78
79allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
80	$< --$@ $(Kconfig)
81
82PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
83
84listnewconfig olddefconfig: $(obj)/conf
85	$< --$@ $(Kconfig)
86
87# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91	$< --olddefconfig $(Kconfig)
92
93savedefconfig: $(obj)/conf
94	$< --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98	$< --defconfig $(Kconfig)
99else
100	@echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101	$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102endif
103
104%_defconfig: $(obj)/conf
105	$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107configfiles=$(wildcard $(srctree)/kernel/configs/$(1).config $(srctree)/arch/$(SRCARCH)/configs/$(1).config)
108
109define mergeconfig
110$(if $(wildcard $(objtree)/.config),, $(error You need an existing .config for this target))
111$(if $(call configfiles,$(1)),, $(error No configuration exists for this target on this architecture))
112$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m -O $(objtree) $(objtree)/.config $(call configfiles,$(1))
113$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
114endef
115
116PHONY += kvmconfig
117kvmconfig:
118	$(call mergeconfig,kvm_guest)
119
120PHONY += tinyconfig
121tinyconfig: allnoconfig
122	$(call mergeconfig,tiny)
123
124# Help text used by make help
125help:
126	@echo  '  config	  - Update current config utilising a line-oriented program'
127	@echo  '  nconfig         - Update current config utilising a ncurses menu based program'
128	@echo  '  menuconfig	  - Update current config utilising a menu based program'
129	@echo  '  xconfig	  - Update current config utilising a QT based front-end'
130	@echo  '  gconfig	  - Update current config utilising a GTK based front-end'
131	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
132	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
133	@echo  '  localyesconfig  - Update current config converting local mods to core'
134	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
135	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
136	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
137	@echo  '  allnoconfig	  - New config where all options are answered with no'
138	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
139	@echo  '  allmodconfig	  - New config selecting modules when possible'
140	@echo  '  alldefconfig    - New config with all symbols set to default'
141	@echo  '  randconfig	  - New config with random answer to all options'
142	@echo  '  listnewconfig   - List new options'
143	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their default value'
144#	@echo  '  kvmconfig	  - Enable additional options for guest kernel support'
145#	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
146
147# lxdialog stuff
148check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
149
150# Use recursively expanded variables so we do not call gcc unless
151# we really need to do so. (Do not call gcc as part of make mrproper)
152HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
153                    -DLOCALE
154
155# ===========================================================================
156# Shared Makefile for the various kconfig executables:
157# conf:	  Used for defconfig, oldconfig and related targets
158# nconf:  Used for the nconfig target.
159#         Utilizes ncurses
160# mconf:  Used for the menuconfig target
161#         Utilizes the lxdialog package
162# qconf:  Used for the xconfig target
163#         Based on QT which needs to be installed to compile it
164# gconf:  Used for the gconfig target
165#         Based on GTK which needs to be installed to compile it
166# object files used by all kconfig flavours
167
168lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
169lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
170
171conf-objs	:= conf.o  zconf.tab.o
172mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
173nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
174kxgettext-objs	:= kxgettext.o zconf.tab.o
175qconf-cxxobjs	:= qconf.o
176qconf-objs	:= zconf.tab.o
177gconf-objs	:= gconf.o zconf.tab.o
178
179hostprogs-y := conf nconf mconf kxgettext qconf gconf
180
181clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
182clean-files	+= zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
183clean-files     += config.pot linux.pot
184
185# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
186PHONY += $(obj)/dochecklxdialog
187$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
188$(obj)/dochecklxdialog:
189	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
190
191always := dochecklxdialog
192
193# Add environment specific flags
194HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
195
196# generated files seem to need this to find local include files
197HOSTCFLAGS_zconf.lex.o	:= -I$(src)
198HOSTCFLAGS_zconf.tab.o	:= -I$(src)
199
200LEX_PREFIX_zconf	:= zconf
201YACC_PREFIX_zconf	:= zconf
202
203HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
204HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
205
206HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
207HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
208                          -Wno-missing-prototypes
209
210HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
211
212HOSTLOADLIBES_nconf	= $(shell \
213				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
214				|| pkg-config --libs menu panel ncurses 2>/dev/null \
215				|| echo "-lmenu -lpanel -lncurses"  )
216$(obj)/qconf.o: $(obj)/.tmp_qtcheck
217
218ifeq ($(MAKECMDGOALS),xconfig)
219$(obj)/.tmp_qtcheck: $(src)/Makefile
220-include $(obj)/.tmp_qtcheck
221
222# QT needs some extra effort...
223$(obj)/.tmp_qtcheck:
224	@set -e; echo "  CHECK   qt"; dir=""; pkg=""; \
225	if ! pkg-config --exists QtCore 2> /dev/null; then \
226	    echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
227	    pkg-config --exists qt 2> /dev/null && pkg=qt; \
228	    pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
229	    if [ -n "$$pkg" ]; then \
230	      cflags="\$$(shell pkg-config $$pkg --cflags)"; \
231	      libs="\$$(shell pkg-config $$pkg --libs)"; \
232	      moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
233	      dir="$$(pkg-config $$pkg --variable=prefix)"; \
234	    else \
235	      for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
236	        if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
237	      done; \
238	      if [ -z "$$dir" ]; then \
239	        echo >&2 "*"; \
240	        echo >&2 "* Unable to find any QT installation. Please make sure that"; \
241	        echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
242	        echo >&2 "* either qmake can be found or install pkg-config or set"; \
243	        echo >&2 "* the QTDIR environment variable to the correct location."; \
244	        echo >&2 "*"; \
245	        false; \
246	      fi; \
247	      libpath=$$dir/lib; lib=qt; osdir=""; \
248	      $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
249	        osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
250	      test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
251	      test -f $$libpath/libqt-mt.so && lib=qt-mt; \
252	      cflags="-I$$dir/include"; \
253	      libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
254	      moc="$$dir/bin/moc"; \
255	    fi; \
256	    if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
257	      echo "*"; \
258	      echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
259	      echo "*"; \
260	      moc="/usr/bin/moc"; \
261	    fi; \
262	else \
263	  cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
264	  libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
265	  moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
266	  [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
267	fi; \
268	echo "KC_QT_CFLAGS=$$cflags" > $@; \
269	echo "KC_QT_LIBS=$$libs" >> $@; \
270	echo "KC_QT_MOC=$$moc" >> $@
271endif
272
273$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
274
275ifeq ($(MAKECMDGOALS),gconfig)
276-include $(obj)/.tmp_gtkcheck
277
278# GTK needs some extra effort, too...
279$(obj)/.tmp_gtkcheck:
280	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
281		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
282			touch $@;								\
283		else									\
284			echo >&2 "*"; 							\
285			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
286			echo >&2 "*";							\
287			false;								\
288		fi									\
289	else										\
290		echo >&2 "*"; 								\
291		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
292		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
293		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
294		echo >&2 "*"; 								\
295		false;									\
296	fi
297endif
298
299$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
300
301$(obj)/qconf.o: $(obj)/qconf.moc
302
303quiet_cmd_moc = MOC     $@
304      cmd_moc = $(KC_QT_MOC) -i $< -o $@
305
306$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
307	$(call cmd,moc)
308
309# Extract gconf menu items for I18N support
310$(obj)/gconf.glade.h: $(obj)/gconf.glade
311	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
312	$(obj)/gconf.glade
313